<!DOCTYPE html>
<html lang="en">

<head>
    <title>Index page</title>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css">
</head>

<body>
    <div class="container">
        <h2 align="center" class="text-danger">Quicksort algorithm in javascript</h2>
        <hr />

        <!-- Quicksort algorithm in javascript. -->
        <div id="title">
            <h4 class="text-info">Definition</h4>
            <ul>
                <li>Fastest searching algorithm for large datasets.</li>
                <li>This algorithm divides the list into sublists by selecting one element as a pivot.</li>
                <li>This algorithm creates two empty arrays to hold elements less than the pivot and elements greater than the pivot, and then recursively sort the sub arrays.</li>
            </ul>
            <div>&nbsp;</div>
        </div>
    </div>
    <script>
        // Quicksort algorithm in javascript.
        function quicksort(arr) {
            if (arr.length == 0) {
                return [];
            }

            var left = [];
            var right = [];
            var pivot = arr[0];

            for (var i = 1; i < arr.length; i++) {
                if (arr[i] < pivot) {
                    left.push(arr[i]);
                } else {
                    right.push(arr[i]);
                }
            }

            return quicksort(left).concat(pivot, quicksort(right));
        }

        // Inputting random array elements.
        var myarray = [];
        for (var i = 0; i < 10; i++) {
            myarray[i] = Math.floor((Math.random() * 100) + 1);
        }
        console.log("Original array: " + myarray);
        
		var sortedarray = quicksort(myarray);
        console.log("Sorted array: " + sortedarray);
    </script>
</body>

</html>